OpenJPH: ojph::local::resolution Class Reference

OpenJPH Open-source implementation of JPEG2000 Part-15

Loading...
Searching...
No Matches
ojph::local::resolution Class Reference

`#include <ojph_resolution.h>`

## Public Types
enum | : ui32 { HORZ_TRX = 0x01 , VERT_TRX = 0x02 }

## Public Member Functions
void | finalize_alloc (codestream *codestream, const rect &res_rect, const rect &recon_res_rect, ui32 comp_num, ui32 res_num, point comp_downsamp, point res_downsamp, tile_comp *parent_tile_comp, resolution *parent_res)
line_buf * | get_line ()
void | push_line ()
line_buf * | pull_line ()
rect | get_rect ()
ui32 | get_comp_num ()
bool | has_horz_transform ()
bool | has_vert_transform ()
ui32 | prepare_precinct ()
void | write_precincts (outfile_base *file)
bool | get_top_left_precinct (point &top_left)
void | write_one_precinct (outfile_base *file)
resolution * | next_resolution ()
void | parse_all_precincts (ui32 &data_left, infile_base *file)
void | parse_one_precinct (ui32 &data_left, infile_base *file)
ui32 | get_num_bytes () const
ui32 | get_num_bytes (ui32 resolution_num) const

## Static Public Member Functions
static void | pre_alloc (codestream *codestream, const rect &res_rect, const rect &recon_res_rect, ui32 comp_num, ui32 res_num)

## Private Attributes
bool | reversible
bool | skipped_res_for_read
bool | skipped_res_for_recon
ui32 | num_steps
ui32 | res_num
ui32 | comp_num
ui32 | num_bytes
point | comp_downsamp
rect | res_rect
line_buf * | lines
lifting_buf * | ssp
lifting_buf * | aug
lifting_buf * | sig
subband * | bands
tile_comp * | parent_comp
resolution * | parent_res
resolution * | child_res
precinct * | precincts
size | num_precincts
size | log_PP
ui32 | max_num_levels
int | tag_tree_size
ui32 | level_index [20]
point | cur_precinct_loc
const param_atk * | atk
ui32 | transform_flags
ui32 | cur_line
ui32 | rows_to_produce
bool | vert_even
bool | horz_even
mem_elastic_allocator * | elastic

## Detailed Description

Definition at line 61 of file ojph_resolution.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum : ui32

Enumerator
HORZ_TRX |
VERT_TRX |

Definition at line 64 of file ojph_resolution.h.

## Member Function Documentation

## ◆ finalize_alloc()

void ojph::local::resolution::finalize_alloc | ( | codestream * | codestream,
|  | const rect & | res_rect,
|  | const rect & | recon_res_rect,
|  | ui32 | comp_num,
|  | ui32 | res_num,
|  | point | comp_downsamp,
|  | point | res_downsamp,
|  | tile_comp * | parent_tile_comp,
|  | resolution * | parent_res )

Definition at line 240 of file ojph_resolution.cpp.

References ojph::local::param_cod::access_atk(), ojph::local::codestream::access_dfs(), ojph::local::codestream::access_qcd(), atk, aug, ojph::local::precinct::bands, bands, ojph::local::param_dfs::BIDIR_DWT, child_res, ojph::local::precinct::coded, comp_downsamp, comp_num, cur_line, cur_precinct_loc, elastic, ojph::local::codestream::get_allocator(), ojph::local::codestream::get_coc(), ojph::local::param_dfs::get_dfs(), ojph::local::param_cod::get_dfs_index(), ojph::local::param_dfs::get_dwt_type(), ojph::local::codestream::get_elastic_alloc(), ojph::local::param_cod::get_log_block_dims(), ojph::local::param_cod::get_log_precinct_size(), ojph::local::param_cod::get_num_decompositions(), ojph::local::codestream::get_precinct_scratch(), ojph::local::param_qcd::get_qcc(), ojph::local::codestream::get_skipped_res_for_read(), ojph::local::codestream::get_skipped_res_for_recon(), ojph::local::tile_comp::get_tile(), ojph::local::tile::get_tile_rect(), ojph::size::h, ojph::local::param_dfs::HORZ_DWT, horz_even, HORZ_TRX, ojph::local::precinct::img_point, ojph::local::param_cod::is_dfs_defined(), level_index, lines, log_PP, max_num_levels, ojph::local::precinct::may_use_sop, ojph::local::param_dfs::NO_DWT, num_bytes, num_precincts, num_steps, OJPH_ERROR, ojph_max, ojph_min, ojph::rect::org, ojph::local::param_cod::packets_may_use_sop(), ojph::local::param_cod::packets_use_eph(), parent_comp, parent_res, ojph::mem_fixed_allocator::post_alloc_data(), ojph::mem_fixed_allocator::post_alloc_obj(), precincts, ojph::local::param_qcd::propose_precision(), res_num, res_rect, reversible, rows_to_produce, ojph::local::precinct::scratch, sig, ojph::rect::siz, skipped_res_for_read, skipped_res_for_recon, ssp, tag_tree_size, transform_flags, ojph::local::precinct::uses_eph, ojph::local::param_dfs::VERT_DWT, vert_even, VERT_TRX, ojph::size::w, ojph::point::x, and ojph::point::y.

## ◆ get_comp_num()

ui32 ojph::local::resolution::get_comp_num | ( |  | ) |
| inline

Definition at line 83 of file ojph_resolution.h.

References comp_num.

## ◆ get_line()

line_buf * ojph::local::resolution::get_line | ( |  | ) |

Definition at line 530 of file ojph_resolution.cpp.

References aug, cur_line, sig, and vert_even.

Referenced by push_line().

## ◆ get_num_bytes() [1/2]

ui32 ojph::local::resolution::get_num_bytes | ( |  | ) | const
| inline

Definition at line 95 of file ojph_resolution.h.

References num_bytes.

Referenced by get_num_bytes().

## ◆ get_num_bytes() [2/2]

ui32 ojph::local::resolution::get_num_bytes | ( | ui32 | resolution_num | ) | const

Definition at line 1038 of file ojph_resolution.cpp.

References child_res, get_num_bytes(), and res_num.

## ◆ get_rect()

rect ojph::local::resolution::get_rect | ( |  | ) |
| inline

Definition at line 82 of file ojph_resolution.h.

References res_rect.

## ◆ get_top_left_precinct()

bool ojph::local::resolution::get_top_left_precinct | ( | point & | top_left | ) |

Definition at line 975 of file ojph_resolution.cpp.

References cur_precinct_loc, num_precincts, and precincts.

Referenced by ojph::local::tile_comp::get_top_left_precinct().

## ◆ has_horz_transform()

bool ojph::local::resolution::has_horz_transform | ( |  | ) |
| inline

Definition at line 84 of file ojph_resolution.h.

References HORZ_TRX, and transform_flags.

## ◆ has_vert_transform()

bool ojph::local::resolution::has_vert_transform | ( |  | ) |
| inline

Definition at line 85 of file ojph_resolution.h.

References transform_flags, and VERT_TRX.

## ◆ next_resolution()

resolution * ojph::local::resolution::next_resolution | ( |  | ) |
| inline

Definition at line 91 of file ojph_resolution.h.

References child_res.

Referenced by ojph::local::tile_comp::get_top_left_precinct(), ojph::local::tile_comp::parse_one_precinct(), ojph::local::tile_comp::parse_precincts(), ojph::local::tile_comp::write_one_precinct(), and ojph::local::tile_comp::write_precincts().

## ◆ parse_all_precincts()

void ojph::local::resolution::parse_all_precincts | ( | ui32 & | data_left,
|  | infile_base * | file )

Definition at line 1001 of file ojph_resolution.cpp.

References cur_precinct_loc, elastic, level_index, num_precincts, ojph::local::precinct::parse(), precincts, skipped_res_for_read, and tag_tree_size.

Referenced by ojph::local::tile_comp::parse_precincts().

## ◆ parse_one_precinct()

void ojph::local::resolution::parse_one_precinct | ( | ui32 & | data_left,
|  | infile_base * | file )

Definition at line 1020 of file ojph_resolution.cpp.

References cur_precinct_loc, elastic, level_index, num_precincts, ojph::local::precinct::parse(), precincts, skipped_res_for_read, and tag_tree_size.

Referenced by ojph::local::tile_comp::parse_one_precinct().

## ◆ pre_alloc()

void ojph::local::resolution::pre_alloc | ( | codestream * | codestream,
|  | const rect & | res_rect,
|  | const rect & | recon_res_rect,
|  | ui32 | comp_num,
|  | ui32 | res_num )
| static

Definition at line 59 of file ojph_resolution.cpp.

References ojph::local::param_cod::access_atk(), ojph::local::codestream::access_dfs(), ojph::local::codestream::access_qcd(), atk, ojph::local::param_dfs::BIDIR_DWT, comp_num, ojph::local::codestream::get_allocator(), ojph::local::codestream::get_coc(), ojph::local::param_dfs::get_dfs(), ojph::local::param_cod::get_dfs_index(), ojph::local::param_dfs::get_dwt_type(), ojph::local::param_cod::get_log_precinct_size(), ojph::local::param_cod::get_num_decompositions(), ojph::local::param_qcd::get_qcc(), ojph::local::codestream::get_skipped_res_for_recon(), ojph::size::h, ojph::local::param_dfs::HORZ_DWT, HORZ_TRX, ojph::local::param_cod::is_dfs_defined(), log_PP, ojph::local::param_dfs::NO_DWT, num_precincts, num_steps, OJPH_ERROR, ojph::rect::org, pre_alloc(), ojph::local::subband::pre_alloc(), ojph::mem_fixed_allocator::pre_alloc_data(), ojph::mem_fixed_allocator::pre_alloc_obj(), res_num, res_rect, reversible, ojph::rect::siz, skipped_res_for_recon, transform_flags, ojph::local::param_dfs::VERT_DWT, VERT_TRX, ojph::size::w, ojph::point::x, and ojph::point::y.

Referenced by pre_alloc(), and ojph::local::tile_comp::pre_alloc().

## ◆ prepare_precinct()

ui32 ojph::local::resolution::prepare_precinct | ( |  | ) |

Definition at line 952 of file ojph_resolution.cpp.

References child_res, elastic, level_index, num_bytes, num_precincts, precincts, prepare_precinct(), res_num, and tag_tree_size.

Referenced by prepare_precinct().

## ◆ pull_line()

line_buf * ojph::local::resolution::pull_line | ( |  | ) |

Definition at line 713 of file ojph_resolution.cpp.

References atk, aug, bands, child_res, cur_line, horz_even, HORZ_TRX, ojph::local::irv_horz_syn, ojph::local::irv_vert_step, ojph::local::irv_vert_times_K, ojph::line_buf::LFT_32BIT, ojph::line_buf::LFT_64BIT, ojph::line_buf::LFT_SIZE_MASK, num_steps, res_num, res_rect, ojph::local::rev_horz_syn, ojph::local::rev_vert_step, reversible, sig, skipped_res_for_recon, ssp, transform_flags, vert_even, and VERT_TRX.

## ◆ push_line()

void ojph::local::resolution::push_line | ( |  | ) |

Definition at line 547 of file ojph_resolution.cpp.

References atk, aug, bands, child_res, cur_line, get_line(), horz_even, ojph::local::irv_horz_ana, ojph::local::irv_vert_step, ojph::local::irv_vert_times_K, ojph::line_buf::LFT_32BIT, ojph::line_buf::LFT_64BIT, num_steps, res_num, res_rect, ojph::local::rev_horz_ana, ojph::local::rev_vert_step, reversible, rows_to_produce, sig, ssp, and vert_even.

## ◆ write_one_precinct()

void ojph::local::resolution::write_one_precinct | ( | outfile_base * | file | ) |

Definition at line 987 of file ojph_resolution.cpp.

References cur_precinct_loc, num_precincts, and precincts.

Referenced by ojph::local::tile_comp::write_one_precinct().

## ◆ write_precincts()

void ojph::local::resolution::write_precincts | ( | outfile_base * | file | ) |

Definition at line 967 of file ojph_resolution.cpp.

References num_precincts, and precincts.

Referenced by ojph::local::tile_comp::write_precincts().

## Member Data Documentation

## ◆ atk

const param_atk* ojph::local::resolution::atk
| private

Definition at line 121 of file ojph_resolution.h.

Referenced by finalize_alloc(), pre_alloc(), pull_line(), and push_line().

## ◆ aug

lifting_buf* ojph::local::resolution::aug
| private

Definition at line 109 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_line(), pull_line(), and push_line().

## ◆ bands

subband* ojph::local::resolution::bands
| private

Definition at line 110 of file ojph_resolution.h.

Referenced by finalize_alloc(), pull_line(), and push_line().

## ◆ child_res

resolution * ojph::local::resolution::child_res
| private

Definition at line 112 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_num_bytes(), next_resolution(), prepare_precinct(), pull_line(), and push_line().

## ◆ comp_downsamp

point ojph::local::resolution::comp_downsamp
| private

Definition at line 105 of file ojph_resolution.h.

Referenced by finalize_alloc().

## ◆ comp_num

ui32 ojph::local::resolution::comp_num
| private

Definition at line 102 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_comp_num(), and pre_alloc().

## ◆ cur_line

ui32 ojph::local::resolution::cur_line
| private

Definition at line 124 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_line(), pull_line(), and push_line().

## ◆ cur_precinct_loc

point ojph::local::resolution::cur_precinct_loc
| private

Definition at line 120 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_top_left_precinct(), parse_all_precincts(), parse_one_precinct(), and write_one_precinct().

## ◆ elastic

mem_elastic_allocator* ojph::local::resolution::elastic
| private

Definition at line 127 of file ojph_resolution.h.

Referenced by finalize_alloc(), parse_all_precincts(), parse_one_precinct(), and prepare_precinct().

## ◆ horz_even

bool ojph::local::resolution::horz_even
| private

Definition at line 126 of file ojph_resolution.h.

Referenced by finalize_alloc(), pull_line(), and push_line().

## ◆ level_index

ui32 ojph::local::resolution::level_index[20]
| private

Definition at line 119 of file ojph_resolution.h.

Referenced by finalize_alloc(), parse_all_precincts(), parse_one_precinct(), and prepare_precinct().

## ◆ lines

line_buf* ojph::local::resolution::lines
| private

Definition at line 107 of file ojph_resolution.h.

Referenced by finalize_alloc().

## ◆ log_PP

size ojph::local::resolution::log_PP
| private

Definition at line 116 of file ojph_resolution.h.

Referenced by finalize_alloc(), and pre_alloc().

## ◆ max_num_levels

ui32 ojph::local::resolution::max_num_levels
| private

Definition at line 117 of file ojph_resolution.h.

Referenced by finalize_alloc().

## ◆ num_bytes

ui32 ojph::local::resolution::num_bytes
| private

Definition at line 103 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_num_bytes(), and prepare_precinct().

## ◆ num_precincts

size ojph::local::resolution::num_precincts
| private

Definition at line 115 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_top_left_precinct(), parse_all_precincts(), parse_one_precinct(), pre_alloc(), prepare_precinct(), write_one_precinct(), and write_precincts().

## ◆ num_steps

ui32 ojph::local::resolution::num_steps
| private

Definition at line 100 of file ojph_resolution.h.

Referenced by finalize_alloc(), pre_alloc(), pull_line(), and push_line().

## ◆ parent_comp

tile_comp* ojph::local::resolution::parent_comp
| private

Definition at line 111 of file ojph_resolution.h.

Referenced by finalize_alloc().

## ◆ parent_res

resolution* ojph::local::resolution::parent_res
| private

Definition at line 112 of file ojph_resolution.h.

Referenced by finalize_alloc().

## ◆ precincts

precinct* ojph::local::resolution::precincts
| private

Definition at line 114 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_top_left_precinct(), parse_all_precincts(), parse_one_precinct(), prepare_precinct(), write_one_precinct(), and write_precincts().

## ◆ res_num

ui32 ojph::local::resolution::res_num
| private

Definition at line 101 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_num_bytes(), pre_alloc(), prepare_precinct(), pull_line(), and push_line().

## ◆ res_rect

rect ojph::local::resolution::res_rect
| private

Definition at line 106 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_rect(), pre_alloc(), pull_line(), and push_line().

## ◆ reversible

bool ojph::local::resolution::reversible
| private

Definition at line 99 of file ojph_resolution.h.

Referenced by finalize_alloc(), pre_alloc(), pull_line(), and push_line().

## ◆ rows_to_produce

ui32 ojph::local::resolution::rows_to_produce
| private

Definition at line 125 of file ojph_resolution.h.

Referenced by finalize_alloc(), and push_line().

## ◆ sig

lifting_buf * ojph::local::resolution::sig
| private

Definition at line 109 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_line(), pull_line(), and push_line().

## ◆ skipped_res_for_read

bool ojph::local::resolution::skipped_res_for_read
| private

Definition at line 99 of file ojph_resolution.h.

Referenced by finalize_alloc(), parse_all_precincts(), and parse_one_precinct().

## ◆ skipped_res_for_recon

bool ojph::local::resolution::skipped_res_for_recon
| private

Definition at line 99 of file ojph_resolution.h.

Referenced by finalize_alloc(), pre_alloc(), and pull_line().

## ◆ ssp

lifting_buf* ojph::local::resolution::ssp
| private

Definition at line 108 of file ojph_resolution.h.

Referenced by finalize_alloc(), pull_line(), and push_line().

## ◆ tag_tree_size

int ojph::local::resolution::tag_tree_size
| private

Definition at line 118 of file ojph_resolution.h.

Referenced by finalize_alloc(), parse_all_precincts(), parse_one_precinct(), and prepare_precinct().

## ◆ transform_flags

ui32 ojph::local::resolution::transform_flags
| private

Definition at line 122 of file ojph_resolution.h.

Referenced by finalize_alloc(), has_horz_transform(), has_vert_transform(), pre_alloc(), and pull_line().

## ◆ vert_even

bool ojph::local::resolution::vert_even
| private

Definition at line 126 of file ojph_resolution.h.

Referenced by finalize_alloc(), get_line(), pull_line(), and push_line().

The documentation for this class was generated from the following files:

- /build/openjph/src/OpenJPH/src/core/codestream/ojph_resolution.h
- /build/openjph/src/OpenJPH/src/core/codestream/ojph_resolution.cpp